#! /bin/sh
#
# Grover N-sided coin simulation

export GDFONTPATH="/usr/share/fonts/open-sans"
export GNUPLOT_DEFAULT_GDFONT="OpenSans-Semibold"

iter=25
m=3

xlabel="Number of iterations"
ylabel="Probability of correct measurement"

for n in 3 8
do
  N=$((1<<n))

  title="Grover's Search, $N-sided coin with 3 heads"
  labels="set title \"$title\"\nset xlabel \"$xlabel\"\nset ylabel \"$ylabel\""

  ./Grover $n $iter 0 $m > Grover-coin-$N.out

  tail -n +2 Grover-coin-$N.out |
   (printf "set term gif\nset output\n $labels\n plot '-' notitle with linespoints\n"; cat) |
   gnuplot > Grover-coin-$N.gif

  iter=100
done
